Home Information Classes Download Usage Mail List Requirements Links Tutorial

# BiQuad Class Reference

STK biquad (two-pole, two-zero) filter class. More...

`#include <BiQuad.h>`

Inheritance diagram for BiQuad:

List of all members.

## Public Member Functions

| BiQuad ()
| Default constructor creates a second-order pass-through filter.
virtual | ~BiQuad ()
| Class destructor.
void | clear (void)
| Clears all internal states of the filter.
void | setB0 (MY_FLOAT b0)
| Set the b[0] coefficient value.
void | setB1 (MY_FLOAT b1)
| Set the b[1] coefficient value.
void | setB2 (MY_FLOAT b2)
| Set the b[2] coefficient value.
void | setA1 (MY_FLOAT a1)
| Set the a[1] coefficient value.
void | setA2 (MY_FLOAT a2)
| Set the a[2] coefficient value.
void | setResonance (MY_FLOAT frequency, MY_FLOAT radius, bool normalize=FALSE)
| Sets the filter coefficients for a resonance at frequency (in Hz).
void | setNotch (MY_FLOAT frequency, MY_FLOAT radius)
| Set the filter coefficients for a notch at frequency (in Hz).
void | setEqualGainZeroes ()
| Sets the filter zeroes for equal resonance gain.
void | setGain (MY_FLOAT theGain)
| Set the filter gain.
MY_FLOAT | getGain (void) const
| Return the current filter gain.
MY_FLOAT | lastOut (void) const
| Return the last computed output value.
MY_FLOAT | tick (MY_FLOAT sample)
| Input one sample to the filter and return one output.
MY_FLOAT * | tick (MY_FLOAT *vector, unsigned int vectorSize)
| Input vectorSize samples to the filter and return an equal number of outputs in vector.

## Detailed Description

STK biquad (two-pole, two-zero) filter class.

This protected Filter subclass implements a two-pole, two-zero digital filter. A method is provided for creating a resonance in the frequency response while maintaining a constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 20 of file BiQuad.h.

## Member Function Documentation

void BiQuad::setResonance | ( | MY_FLOAT | frequency,
|  | MY_FLOAT | radius,
|  | bool | normalize = FALSE
| ) |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the filter zeros are placed at z = 1, z = -1, and the coefficients are then normalized to produce a constant unity peak gain (independent of the filter gain parameter). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width.

void BiQuad::setNotch | ( | MY_FLOAT | frequency,
|  | MY_FLOAT | radius
| ) |

| Set the filter coefficients for a notch at frequency (in Hz). This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. No filter normalization is attempted.

void BiQuad::setEqualGainZeroes | ( |  | ) |

| Sets the filter zeroes for equal resonance gain. When using the filter as a resonator, zeroes places at z = 1, z = -1 will result in a constant gain at resonance of 1 / (1 - R), where R is the pole radius setting.

void BiQuad::setGain | ( | MY_FLOAT | theGain | ) | `[virtual]`

| Set the filter gain. The gain is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. Reimplemented from Filter.

The documentation for this class was generated from the following file:

- BiQuad.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.